module.exports = function(grunt) {
	
	grunt.initConfig({
		
		sass: {
			options: {
				sourceMap: true
			},
			dist: {
				files: {
					'dist/styles/style.css': 'dev/styles/style.scss'
				}
			}
		},

		autoprefixer: {
			options: {
				browsers: ['last 2 versions', 'ie 8', 'ie 9', '> 1%']
			},
			dist: {
				expand: true,
				flatten: true,
				src: 'dist/styles/style.css'
			}
		},
				
		jshint: {
			all: ['dev/scripts/**/*.js']
		},
		
		uglify: {
			dist: {
				files: {
					'dist/scripts/script-min.js': ['dev/scripts/script.js']
				}
			}
		},
		
		watch: {
			scripts: {
				files: ['dev/scripts/**/*.js'],
				tasks: ['jshint', 'uglify', 'notify:scripts']
			},
			sass:{
				files:['dev/styles/**/*.*'],
				tasks:['sass', 'autoprefixer', 'notify:sass']
			},
			options: {
			}
		},
		
		notify: {
			server: {
				options: {
					title: 'Grunt ready',
					message: 'Grunt start finished running', 
				}
			},
			scripts: {
				options: {
					title: 'Scripts Complete',
					message: 'Scripts finished running',
				}
			},
			sass: {
				options: {
					title: 'SASS Complete',
					message: 'SASS finished running',
				}
			}
		},
		
	});
	 
	grunt.loadNpmTasks('grunt-sass');
	grunt.loadNpmTasks('grunt-autoprefixer');
	grunt.loadNpmTasks('grunt-contrib-jshint');
	grunt.loadNpmTasks('grunt-contrib-uglify');
	grunt.loadNpmTasks('grunt-contrib-watch');
	grunt.loadNpmTasks('grunt-notify');
	 
	grunt.registerTask('default', ['sass', 'autoprefixer', 'jshint', 'uglify', 'notify:server', 'watch']);
	
}