/*jslint browser:true, devel:true, white:true, vars:true */
/*global $:false, intel:false, dev:false, performance:false, XtemplateAutoloader:false, USER_ID:true, USER_TOKEN:true, Photo: false */

var APP_INTERNAL_VERSION                = '20160822';
var APP_ANALYTICS_CODE                  = '73V95DZ8XCTW25ZSW28B';
var JS_PAGE_CONTROLLER_PATH             = 'js/sections/';
var API_ERR_CODE_SUCCESS 				= 0;
var API_ERR_CODE_INVALID_REQUEST 		= 1;
var API_ERR_CODE_INVALID_CREDENTIALS 	= 2;
var API_ERR_CODE_INVALID_ACCOUNT 		= 3;
var API_ERR_CODE_SENDMAIL_PROBLEM 		= 4;
var API_ERR_CODE_EMPTY_PASSWORD 		= 5;
var API_ERR_CODE_DIFFERENT_PASSWORDS	= 6;
var API_ERR_CODE_EXISTING_ACCOUNT 		= 7;
var API_ERR_CODE_TOKEN_EXPIRED 			= 8;
var API_ERR_CODE_INVALID_TOKEN 			= 9;

var xt,xtrl, showAjaxLoader = true, suppressErrors = false;

var tickets = [],
	applicationOnLine = true;

var methods             = {},
	inEmulator          = !window['cordova'],
	production          = true,
	// pixelRatio          = window.devicePixelRatio || 1;
	remoteHost          = production?'http://www.theselfierun.it': 'http://beta.theselfierun.it',
	APIEntryPoint       = remoteHost + '/api/v1',
	previousAjaxRequest = null;

window.debuggable = false;

function getTickets(){

	ask({
		url: '/user/getTickets',
		method: 'get',
		cancellable: false
	} ).success( function(response){
		// console.log(response);
		console.log(response);
		if(response.status == 'KO') {
			setUserToken('');
			setUserName('');
			setUserID('');
			setAnonymousTemplate();

		}else{
			tickets = response.ticket;
		}
	});
}


function ask( args ){
	"use strict";
	if(typeof(args) == 'string') args = { url: args };

	args.url = APIEntryPoint + args.url;
	args.dataType = args.dataType 	    || 'json';
	args.type = args.type 			    || 'post';
	args.data = args.data               || {};
	args.cancellable = args.cancellable!==undefined?args.cancellable:true;
	args.cache = args.cache             || false;
	args.xhrFields = {
		// The 'xhrFields' property sets additional fields on the XMLHttpRequest.
		// This can be used to set the 'withCredentials' property.
		// Set the value to 'true' if you'd like to pass cookies to the server.
		// If this is enabled, your server must respond with the header
		// 'Access-Control-Allow-Credentials: true'.
		withCredentials: false
	};
	args.xhr = window.myXMLHttpRequest;
	args.crossDomain = true;
	if(window['USER_ID'] && USER_ID !== '') args.data.uid = USER_ID;
	if(window['USER_TOKEN'] && USER_TOKEN !== '') args.data.token = USER_TOKEN;

	if(previousAjaxRequest && previousAjaxRequest.args.cancellable && previousAjaxRequest.readyState && previousAjaxRequest.readyState != 4 ){
		suppressErrors = true;
		previousAjaxRequest.abort();
		suppressErrors = false;
		// console.log(previousAjaxRequest.readyState);
	}

	previousAjaxRequest = $.ajax(args);
	previousAjaxRequest.args = args;
	previousAjaxRequest.always(function(responseData, responseMessage) {
		// Evitiamo l'error 0
		if(responseData.status && responseData.status == 0){
			responseData.status = 200;
			responseMessage = '';
			previousAjaxRequest
				.success( responseData.responseJSON || responseData.responseText )
				.done( responseData.responseJSON || responseData.responseText );
		}else if(responseData.status && !isNaN(responseData.status)){

			console.log(responseData)
			console.log(responseMessage);
		}
	}).success(function(data){

		if(data.notified) {
			showNotifications(data.notified);
		}
	});


	return previousAjaxRequest;
	
}
if(APP_ANALYTICS_CODE) {
	var FlurryAgent = FlurryAgent || {
			startSession: function () {
			},
			setAppVersion: function () {
			},
			logEvent: function () {
			},
			setUserId: function () {
			}
		};
}

var appIsReady = false;
var appIsLoaded = false;

function onAppReadyAndLoaded(){

	"use strict";
	xt = new Xtemplate();

	xt.off('afterApply').on('afterApply', function(details){
		$('img', details.intoId).off('error').on('error', function(){
			$(this).attr('src', 'images/logo.png');
		});
	});

	xtrl = new XtemplateRemoteLoader({
		xtemplateInstance: xt
	});

	document.addEventListener("offline", checkConnection, false);
	document.addEventListener("online", checkConnection, false);

	function checkConnection() {
		applicationOnLine = navigator.connection.type != Connection.UNKNOWN &&
			navigator.connection.type != Connection.NONE;
	}

	checkConnection();
	loadUserData();

	$('body').addClass( device.platform.toLowerCase().replace('-', '') );

	if(window['appHistory'] && appHistory.back) {
		document.addEventListener('backbutton', appHistory.back, false);
		$(document).on('click','.back', appHistory.back);
	}
	if(APP_ANALYTICS_CODE && window['FlurryAgent']){
		FlurryAgent.startSession(APP_ANALYTICS_CODE);
		FlurryAgent.setAppVersion(APP_INTERNAL_VERSION);
	}


	// FlurryAgent.logEvent("Info dispositivo", env); // save the OS and Browser

	if(USER_TOKEN!=''){
		getTickets();
	}
	activateSection('#main-screen');

	if( navigator.splashscreen && navigator.splashscreen.hide ) {   // Cordova API detected
		navigator.splashscreen.hide() ;
	}


	$( document )
		.ajaxStart(function() {
			if(showAjaxLoader) {
				$('body').addClass('loading');
			}
		})
		.ajaxStop(function() {
			$('body').removeClass('loading');

		}).ajaxError(function( event, request, settings ) {
		$('body').removeClass('loading');
		console.log(event);

		if(request.status == 0){
			request
				.success( request.responseJSON || request.responseText )
				.done( request.responseJSON || request.responseText );
		}
		if(!/\.js(\?.*)$/.test(settings.url) && !suppressErrors )
			showErrorMessage("Errore di comunicazione", "Impossibile raggiungere l'indirizzo " + settings.url);

	});;

	$('body').removeClass('loading');

	XtemplateAutoloader( xt );

	function watchChanges(event){
		var id = this.id,
			val = $(this).val().trim();

		// console.log(id);
		if(val !== ''){
			$('.on-' + id + '-filled').slideDown();
		}else{
			$('.on-' + id + '-filled').slideUp();
		}
	}

	function dataAsk(event){

		var $this = $(this),
			itemData = $this.data(),
			api = itemData.ask,
			callback = itemData.response,
			form = $this.parents('form'),
			args = itemData.arguments,
			fields = $('input,select,textarea', form).not(':button'),
			method = itemData.askMethod || 'post',
			data = {},
			msg = '';

		if(itemData.asked === true){
			// console.log('do the consequence');
			$this.data('asked', false);
			data = itemData.askedData;
			console.log(data);
			if(data.status == 'OK'){
				if(data.token) USER_TOKEN = data.token;

				// console.log(data);
				if(callback && window[callback] && typeof(window[callback]) == 'function'){

					window[callback].call($this[0],data);

				}else{

					if($this.data('then')){
						var thenScreen = $this.data('then');
						activateSection( thenScreen );
					}

				}
			}else{

				if(callback && window[callback] && typeof(window[callback]) == 'function'){
					window[callback].call($this[0],data);
				}

			}


			return;
		}else{
			// console.log('asking for something');
			if( event ){
				event.preventDefault();
				event.stopPropagation();
				event.stopImmediatePropagation();
			}


			if( itemData.askConfirm && !itemData.confirmed ) {
				var dialog = $('#confirm-action-dialog');
				dialog.find('.modal-body').html(itemData.askConfirm);
				dialog.find('.modal-title').html(itemData.askConfirmTitle || '&nbsp;');

				dialog.modal('show');
				$('#confirm-action-ok-button').off().on('click', function(){
					$this.data('confirmed', true);
					dataAsk.apply($this[0]);
					$this.data('confirmed', false);
					dialog.modal('hide');
				});
				return false;
			}



			if(args){
				var baseArgs = args.split(',');
				baseArgs.forEach( function( value ){
					data[value] = $this.data('arguments-' + value);
				});
			}
			var error = false;
			fields.each(function(){
				var $this = $(this),
					isValid = $this[0].checkValidity(),
					fieldData = $this.data(),
					key = $this.attr('name'),
					subkey = false,
					isArray = false,
					isCheckable = ($this.is(':checkbox') || $this.is(':radio')),
					val = $this.val();


				if(isCheckable && ! $this.is(':checked')) val = '';

				if( /\[/.test(key) ){
					subkey = key.replace(/^.*\[(.*?)]$/, '$1');
					key = key.replace(/\[.*]$/, '');
					isArray = true;
				}

				if( (( isCheckable && $this.is(':checked')) || !isCheckable ) && key && isValid ){
					if(isArray){
						if($.isArray(data[key]) || $.isPlainObject(data[key]) ){

							if(subkey){
								data[key][subkey] = val;
							}else{
								data[key].push(val);
							}
						}else{
							if(subkey){
								data[key] = {};
								data[key][subkey] = val;
							}else{
								data[key] = [val];
							}
						}
					}else{
						data[key] = val;
					}
				}else{
					if(!isValid){

						var curMsg = '';
						console.log(this);
						if($this.is('[required]') && val==''){
							curMsg += fieldData.requiredMessage || ($this.attr('id') + ' obbligatorio');

						}else{
							curMsg += fieldData.invalidMessage || ($this.attr('id') + ' non valido');
						}

						msg += ((curMsg!='')? curMsg+'\n':'');
						error = true;
					}

				}
			});
			if(error || (form.length > 0 && !form[0].checkValidity())){
				showErrorMessage('I dati forniti sono errati o incompleti<br />' + msg.replace(/\n/g, '<br />'));
				return false;
			} else {
				var asking = ask({
					url: api,
					method: method,
					data: data,
					cancellable: false,
				}).success(function(data){
					// console.log('here!');
					$this.data('asked', true);
					$this.data('asked-data', data);
					dataAsk.apply($this[0]);

				});

				return true;
			}
		}
	}
	$(window).on('resize', function(event){
		/*
		 $('section.current').css('display', 'none');
		 $('section.current')[0].offsetHeight; // no need to store this anywhere, the reference is enough
		 $('section.current').css('display', 'block');
		 */

	});
	$(document)
		.on('screenchanged', function(event, eventData){
			var item = $('input:focus,textarea:focus');
			if( item.length > 0 ) {
				var maxTop = item.offset().top - parseInt($(window).height() / 2);
				if (maxTop < 0) maxTop = 0;
				$('section.current').scrollTop( maxTop );
			}

		})
		.on('change', 'input[type=file]', function(event){
			var
				theInput        = $(this),
				theForm         = $(this).parents('form'),
				selectedFile    = theInput.get(0).files[0],
				hiddenFields    = $('input[type=hidden]', theForm),
				theContainer    = theInput.parents('div:first'),
				theProgressBar  = theContainer.prev(),
				reader          = new FileReader(),
				formData        = new FormData();

			reader.onload = function(e) {
				/* Mostro l'anteprima */
				theContainer.css('background-image', 'url(' + e.target.result +')' );
				$('span', theProgressBar).width(0);
				theProgressBar.show('fast');
				formData.append('uid', USER_ID);
				formData.append('token', USER_TOKEN);
				formData.append('index', theInput.attr('name').replace(/[^\d]/g, '') );

				hiddenFields.each(function(){
					formData.append( $(this).attr('name'), $(this).val() );
				});

				var URL = remoteHost + theForm.attr('action')
				formData.append('resource', selectedFile );
				$.ajax({
					url: URL, //server script to process data
					type: 'POST',
					xhr: function () {  // custom xhr
						var myXhr = $.ajaxSettings.xhr();
						if (myXhr.upload) {

							myXhr.upload.addEventListener('progress', function(e){
								if (e.lengthComputable) {
									var percentage = Math.round((e.loaded * 100) / e.total);

									$('span', theProgressBar).css('width', percentage + '%');

								}
							}, false);
						}
						return myXhr;
					},
					data: formData,
					dataType: 'json',
					cache: false,
					contentType: false,
					processData: false
				}).complete( function(data){
					theProgressBar.hide('fast');
				});
			};
			reader.readAsDataURL(selectedFile);
		})
		.on('click', '[data-delegate]', function(event){
			event.preventDefault();
			var delegateSelector = $(this).data('delegate');
			$(delegateSelector).trigger('click');
		})
		.on('keyup', '.watch-changes', watchChanges)
		.on('click', '[data-remove-parent=true]', function(event){
			event.preventDefault();

			var onRemoveHandler = $(this).data('on-remove');
			$(this).parent().remove();

			if(onRemoveHandler && typeof(window[onRemoveHandler]) == 'function'){
				var fn = window[onRemoveHandler];
				fn();
			}

		})
		.on('click', '[data-remove-self=true]', function(event){
			event.preventDefault();

			var onRemoveHandler = $(this).data('on-remove');
			$(this).remove();

			if(onRemoveHandler && typeof(window[onRemoveHandler]) == 'function'){
				var fn = window[onRemoveHandler];
				fn();
			}

		})
		.on('click', 'a[target]', function(event){
			event.preventDefault();
			var href = $(this).attr('href'),
				target = $(this).attr('target');

			window.open(href, target);

		})
		.on('click', '[data-ask]', dataAsk)

		.on('click', '[data-search]', function(event){
			event.preventDefault();
			$('#search-field').val( $(this).data('search'));
			activateSection('#main-screen');
		})
		.on('click', '*[data-page]', function(event){
			event.preventDefault();
			var data = $(this).data();

			if( data.resourceId ){
				activateSection( '#' + data.page, data.resourceId );
			}else{
				activateSection( '#' + data.page );
			}
		})
		.on('submit', 'form', function(event) {
			event.preventDefault();
		});


}

function onAppReady() {

	appIsReady = true;
	if(appIsReady && appIsLoaded) onAppReadyAndLoaded();

}

window.suspendFromCamera = false;

$(window).on('load', function(){
	appIsLoaded = true;
	if(inEmulator){
		Connection = {
			UNKNOWN: 0,
			NONE: 0
		};
		navigator.connection = {
			type: 1
		};
		appIsReady = true;
		window.device = { platform: 'ios' };
	}
	if(appIsReady && appIsLoaded) onAppReadyAndLoaded();
});


document.addEventListener("deviceready", onAppReady, false);

function activateSection(id, extraData){

	if(APP_ANALYTICS_CODE) {
		FlurryAgent.logEvent("Richiesto spostamento su schermata " + id, extraData);
	}
	if(window['appHistory'] && appHistory.push)
		appHistory.push(id,extraData);


	function completed(){
		$('body > section').not(id).removeClass('current');
		$(id).addClass('current');
		$(id).trigger('activate-screen', extraData);
	}

	if(methods[id] || methods[id] === false){
		completed();
	} else {
		$.getScript(JS_PAGE_CONTROLLER_PATH + id.substr(1) + '.js')
			.complete(function (data, status) {

				if(status !== 'error') {
					methods[id]();
				}else{
					methods[id] = false;
				}
				setTimeout(completed, 0);
			});
	}
}

$.fn.extend({
	disableSelection: function() {
		this.each(function() {
			this.onselectstart = function() {
				return false;
			};
			this.unselectable = "on";
			$(this).css('-moz-user-select', 'none');
			$(this).css('-webkit-user-select', 'none');
		});
		return this;
	}
});