/**
 * Created by diego on 12/04/16.
 */

var appHistory = {
	onEmptyQuit: true,
	tracking: true,
	_history: [],
	isBack: false,
	push: function( id, extraData ){
		var found = false;
		if(appHistory.tracking) {
			extraData = extraData || null;

			this._history.forEach(function (item, index) {
				var that = this;
				if (item && item.id == id && JSON.stringify(extraData) == JSON.stringify(item.extraData)) {
					console.log('history for ' + id + ' removed');
					appHistory._history[index] = null;

				}
			});
			this.garbaging();
			this._history.push({id: id, extraData: extraData});
		}
	},

	replace: function( id, extraData ){
		this._history[this._history.length-1].id = (id!=null)?id:this._history[this._history.length-1].id;
		this._history[this._history.length-1].extraData = extraData;
	},

	remove: function(id){

		if($.isArray(id)) return id.forEach(appHistory.remove);

		var newHistory = [];
		this._history.forEach(function(item){
			if(item.id != id) newHistory.push(item);
		});
		this._history = newHistory;
	},

	pop: function( ){

		return appHistory._history.pop();

	},

	doNotTrack: function(){
		appHistory.tracking = false;
	},
	doTrack: function(){
		appHistory.tracking = true;
	},
	garbaging: function(){

		var newHistory = [];

		appHistory._history.forEach(function(item){
			if( item != null ) {
				newHistory.push(item);
			}
		});
		appHistory._history = newHistory;

	},
	back: function( event ){
		
		if(event) event.preventDefault();
		var currentInHistory    = appHistory.pop(); // La schermata correntemente visualizzata
		var previousInHistory   = appHistory.pop(); // La schermata precedente
		// console.log(appHistory._history.map( function(item){ return item.id }));

		if(currentInHistory && previousInHistory) $(currentInHistory.id).trigger('history-back', previousInHistory.id);

		// console.log(appHistory._history.map( function(item){ return item.id }));

		if(previousInHistory === undefined){

			if(appHistory.onEmptyQuit){
				if(window['cordova']) {
					navigator.app.exitApp();
				}else {
					alert("Application quit!");
				}
			}

		} else {
			appHistory.isBack = true;
			// appHistory.doNotTrack();
			activateSection(previousInHistory.id, previousInHistory.extraData);
			// appHistory.doTrack();
			appHistory.isBack = false;
		}
	}
};

$(document).on('click', '[data-action="back"]', function(event){
	appHistory.back(event);
});
