/**
 * Created by diego on 9/1/16.
 */
methods['#map-photo'] = function () {

	var imageURI = false;

	function cameraSuccess(fileURI) {
		$('#temp-img-map').attr('src', fileURI);
		imageURI = fileURI;
	}

	function cameraError(message) {
		showErrorMessage("Errore fotocamera")
		appHistory.back();
	}

	function onUploadSuccess(r) {
		if (r.responseCode == 200) {

			var response = JSON.parse(r.response);
			if (response.status == 'KO') {
				showErrorMessage("Errore di trasmissione", response.message.description, response.message.code);
			} else {
				showSuccessMessage("Trasmissione foto", "Immagine pubblicata!", '');
				appHistory.back();
			}
		} else {
			showErrorMessage("Errore di trasmissione", "C'è stato qualche problema tecnico, riprova tra qualche secondo...", 'HTTP_' + r.response);
		}
	}

	function onUploadError(error) {
		var extraMsg = [
			/* 0 */ 'Nessun errore',
			/* 1 = FileTransferError.FILE_NOT_FOUND_ERR */ 'Risorsa locale non trovata',
			/* 2 = FileTransferError.INVALID_URL_ERR */ 'Destinazione non valida',
			/* 3 = FileTransferError.CONNECTION_ERR */ 'Errore di connessione',
			/* 4 = FileTransferError.ABORT_ERR */ 'Operazione annullata',
			/* 5 = FileTransferError.NOT_MODIFIED_ERR */ 'Richiesta duplicata'
		];

		showErrorMessage("Errore nel caricamento", "C'è stato un problema nel caricamento della foto.<br />" + extraMsg[error.code] + '.', error.code);

		console.log("upload error source " + error.source);
		console.log("upload error target " + error.target);

	}

	function sendPhoto() {

		console.log("Sending Photo to server");

		var options = new FileUploadOptions();
		options.fileKey = "media";
		options.fileName = imageURI.substr(imageURI.lastIndexOf('/') + 1);
		options.mimeType = "image/jpeg";

		var params = {
			lat: window.mapArgs.currentPoi.lat,
			lon: window.mapArgs.currentPoi.lng,
			token: USER_TOKEN
		};

		if (window.mapArgs.estroso) {
			params.estroso = 'yes';
		}

		options.params = params;

		var ft = new FileTransfer();
		ft.upload(imageURI, encodeURI(APIEntryPoint + '/photo/add'), onUploadSuccess, onUploadError, options);

	}

	function takeAPhoto(event) {

		if (event) event.preventDefault();
		var cameraOptions = {
			quality: 70,
			correctOrientation: true,
			saveToPhotoAlbum: true,
			cameraDirection: Camera.Direction.FRONT
		};
		navigator.camera.getPicture(cameraSuccess, cameraError, cameraOptions);
	}

	$(document)
		.on('activate-screen', '#map-photo', function () {
			console.log("map-photo");
			takeAPhoto();

		})
		.on('click', '#retake-photo', takeAPhoto)
		.on('click', '#confirm-photo', sendPhoto);

};