/**
 * Created by diego on 9/1/16.
 */

methods['#map-screen'] = function () {

	var map = false,
		markers = [];

	if(window['mapArgs'] === undefined) window.mapArgs = {
		estroso: false
	};

	function getDistanceFromLatLonInKm(lat1,lon1,lat2,lon2) {
		var R = 6371; // Radius of the earth in km
		var dLat = deg2rad(lat2-lat1);  // deg2rad below
		var dLon = deg2rad(lon2-lon1);
		var a =
				Math.sin(dLat/2) * Math.sin(dLat/2) +
				Math.cos(deg2rad(lat1)) * Math.cos(deg2rad(lat2)) *
				Math.sin(dLon/2) * Math.sin(dLon/2)
			;
		var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a));
		var d = R * c; // Distance in km
		return d;
	}

	function deg2rad(deg) {
		return deg * (Math.PI/180)
	}

	// Sets the map on all markers in the array.
	function setMapOnAll(map) {
		for (var i = 0; i < markers.length; i++) {
			markers[i].setMap(map);
		}
	}

	function takePicture(position){
		var lat = null,
			lng = null;

		if(position){
			window.mapArgs.estroso = false;
			lat = position.lat();
			lng = position.lng();
			window.mapArgs.currentPoi = {
				lat: lat,
				lng: lng
			};
		}else{

			/*
			 * La posizione non viene fornita se si tratta del selfie più estroso
			 */

			window.mapArgs.estroso = true;
		}

		// console.log(position.lat(), position.lng());
		activateSection('#map-photo');
	}

	function addMarker(location) {

		var marker = new google.maps.Marker({
			position: location,
			map: map
		});
		marker.addListener('click', function() {
			takePicture( marker.getPosition() );
		});
		markers.push(marker);

	}

	$(document).on('activate-screen', '#map-screen', function () {
		if( map === false) {

			var latLon = new google.maps.LatLng(window.mapArgs.lat,window.mapArgs.lon),
				mapOptions = {zoom: 14,center: latLon };

			map = new google.maps.Map(document.getElementById('map-container'), mapOptions);
		}

		setMapOnAll(null);
		var poi = window.mapArgs.poi || [];
		if(poi.length == ''){
			$('#selfie-estroso').hide();
		}else{
			$('#selfie-estroso').show();
		}
		console.log('adding markers');
		for(var i =0; i<poi.length; i++){
			addMarker( new google.maps.LatLng(poi[i].lat,poi[i].lon) );
		}
	}).on('click', '#selfie-estroso', function (event) {

		function geolocationSuccess(position){

			window.mapArgs.currentPoi = {
				lat: position.coords.latitude,
				lng: position.coords.longitude
			};

			takePicture();
		}
		
		function geolocationError(error) {
			showErrorMessage('Impossibile ottenere la posizione esatta', error.message, error.code);

		}
		
		navigator.geolocation.getCurrentPosition(geolocationSuccess,
			geolocationError,
			{
				maximumAge: 3000, 
				timeout: 5000, 
				enableHighAccuracy: true
			});

		event.preventDefault();



	});

};